---------------------------------------------------------------------------------------------------
-- The cursor we're going to be moving around


local Cursor = {
    tileX = 1,              -- The horizontal tile
    tileY = 1,              -- The vertical tile
    -- The image
    --image = love.graphics.newImage("images/Cursor.png"),
}



---------------------------------------------------------------------------------------------------
-- Move the Cursor to the relative location
function Cursor.move(x,y,layer)
    
    -- Grab the tile
    local tile = layer(Cursor.tileX+x, Cursor.tileY+y)
    
    -- If the tile doesn't exist or is an obstacle then exit the function
    if tile == nil then return end

    -- Otherwise change the Cursor's tile
    Cursor.tileX = Cursor.tileX + x
    Cursor.tileY = Cursor.tileY + y 
end


---------------------------------------------------------------------------------------------------
-- Draw our Cursor. This function is passed to TileSet.drawAfterTile() which calls it passing the
-- x and y value of the bottom left corner of the tile.
function Cursor.draw(x,y)
    lg.line(x,y-32,x+64,y)
    lg.line(x+64,y,x+128,y-32)
    lg.line(x,y-128,x+64,y-96)
    lg.line(x+64,y-96,x+128,y-128)
    lg.line(x+64,y,x+64,y-96)
    lg.circle("fill",x+64,y-128,10)
    --love.graphics.drawq(Cursor.image, Cursor.quads[Cursor.facing], x+15, y-80)
end

function Cursor.reset()

    Cursor.tileX = 1
    Cursor.tileY = 1
    Cursor.facing = "downleft"

end

return Cursor

