local Guy = {} --dontbreak

--Load images only once instead of on every instantiation
local guyimage = love.graphics.newImage("images/guy.png")

--Generic quads used for each creature
local protoquads = {               -- The frames of the image
        down =      love.graphics.newQuad(0,0,32,64,256,64),
        downright = love.graphics.newQuad(32,0,32,64,256,64),
        right =     love.graphics.newQuad(64,0,32,64,256,64),
        upright =   love.graphics.newQuad(96,0,32,64,256,64),
        up =        love.graphics.newQuad(128,0,32,64,256,64),
        upleft =    love.graphics.newQuad(160,0,32,64,256,64),
        left =      love.graphics.newQuad(192,0,32,64,256,64),
        downleft =  love.graphics.newQuad(224,0,32,64,256,64),
    }
    
local creatures={
	imp=
	{
		id=0,
		uniqueid=0,
		x=0,y=0,
		gx=1,gy=1,
		currentjob=nil,
		health=100,
		name="imp",
		pathingfails=0,
		player=1,
		type="creature",
		
		--Stores the path the creature is currently walking
		
		walkingpath={},
		pathstep=1,
		
		--Used for drawing isometric graphic 
		quads = protoquads,
		image = guyimage,
		facing = "downleft",
		
		draw=	
				function(self)
						love.graphics.drawq(self.image, self.quads[self.facing], self.x, self.y)				
				end,
		
		--FIXME: CRAP Used to stop creature looking for new jobs 
		idle = false,
		
		--Jobs the creature can perform/will search for
		jobs={"mine","harvest","claim"},
				
		--Speed at which a creature will perform jobs		
		efficiency={mine=10,claim=20},
		
		--Not used yet, assume it will be used to check things like hunger and sleep
		needs={}
	}
}






---------------------------------------------------------------------------------------------------
-- Move the guy to the relative location
function Guy.move(x,y)

    -- Change the facing direction
    if x > 0 then Guy.facing = "downright"
    elseif x < 0 then Guy.facing = "upleft"
    elseif y > 0 then Guy.facing = "downleft"
    else Guy.facing = "upright" end
    
    -- Grab the tile
    local tile = backgroundlayer(Guy.tileX+x, Guy.tileY+y)
    
    -- If the tile doesn't exist or is an obstacle then exit the function
    if tile == nil then return end
    if tile.properties.obstacle then return end
    
    -- Otherwise change the guy's tile
    Guy.tileX = Guy.tileX + x
    Guy.tileY = Guy.tileY + y 
end


---------------------------------------------------------------------------------------------------
-- Tile based draw
-- Add the guy to be drawn after the tile he's on
-- layer:setAfterTileFunction( function(layer, tileX, tileY, drawX, drawY)
--    if tileX == Guy.tileX and tileY == Guy.tileY then Guy.draw(drawX, drawY) end
-- end )

return creatures
