local ui={
	prototype={
		--used for searching through table, mainly for loading from a map
		id=nil,
		--name of the ui element, same as the table key, also used for searching
		name="",
		--text drawn on the element to identify it
		label="",
		--type of entity
		type="ui",
		--uniqueid of ui element (not really unique yet or used for anything other than debug)
		uniqueid="",
		--actual drawing co-ords
		x=0,
		y=0,
		--cordinates on the grid (if it is an element placed in a grid)
		gx=0,
		gy=0,
		--sizes
		width=0,
		height=0,
		--jobs that the ui element can create
		jobs={},
		color={150,150,150},
		--state of ui element
		clicked=false,
		--graphical representation of element
		draw=function(self) end,
		
		--callback for when element is clicked
		onclick=function(self) end,
	}

}

-- UI Button Element

ui.button = deepcopy(ui.prototype)
ui.button.width = 150
ui.button.height = 30
ui.button.label = "Button"
ui.button.draw = function(self)
	--print("drawing")
	lg.setColor(self.color)
	lg.rectangle("fill",self.x,self.y,self.width,self.height)
	if(self.hover) then lg.setColor(50,50,50) else lg.setColor(0,0,0) end
	
	lg.print(self.label,self.x+self.width/2-(3*#self.label),self.y+self.height/2-4)

end

-- Panel UI Container

ui.panel=deepcopy(ui.prototype)
ui.panel.color = {0,0,0}
ui.panel.contents = {}
ui.panel.border = 5
ui.panel.draw = function(self)

	lg.setColor(self.color)
	if(self.hover) then lg.setColor(50,50,50) else lg.setColor(0,0,0) end

	lg.rectangle("fill",self.x,self.y,self.width,self.height)
	
	for id,element in pairs(self.contents) do
		element:draw()
	end

end

ui.panel.add = function(self,element)
	element.x = self.x+self.border
	element.y = self.height + self.y
	table.insert(self.contents,element)
	self.width=math.max(element.width+self.border*2,self.width)
	self.height = self.height + element.height + self.border
end

return ui
